'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable no-console */
/* eslint-disable react/forbid-prop-types */

// This has been completely stolen from @threepointone's amazing original
// implementation which can be found here:
// https://github.com/threepointone/react-modules
// Go look at his implementation! It is far more featureful.
// All props go to Sunil! Love love love.

var BABEL_PLUGIN_REQUIRED_MESSAGE = 'You must use the CodeSplitComponent with it\'s babel plugin.\n\nFor e.g.\n  { "plugins": ["code-split-component/babel"] }\n\nIf you don\'t want to disable the code splitting feature without removing the CodeSplitComponent from your source then you can set the "noCodeSplitting" option for the babel plugin to `true`.\n\nFor e.g.\n  { "plugins": [["code-split-component/babel", { "noCodeSplitting": true }]] }\n';

function es6Safe(module) {
  return module.default ? module.default : module;
}

var CodeSplitComponent = function (_Component) {
  _inherits(CodeSplitComponent, _Component);

  function CodeSplitComponent(props) {
    _classCallCheck(this, CodeSplitComponent);

    var _this = _possibleConstructorReturn(this, (CodeSplitComponent.__proto__ || Object.getPrototypeOf(CodeSplitComponent)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(CodeSplitComponent, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var _props = this.props;
      var path = _props.path;
      var noCodeSplitting = _props.noCodeSplitting;
      var onError = _props.onError;


      if (typeof path === 'string') {
        throw new Error(BABEL_PLUGIN_REQUIRED_MESSAGE);
      }

      if (noCodeSplitting) {
        // We have a require expression result.
        this.state = { component: es6Safe(path) };
      } else {
        // We have a System.import promise.
        path.then(function (component) {
          return _this2.setState({ component: es6Safe(component) });
        }).catch(function (err) {
          return onError ? onError(err) : console.log(err);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(this.state.component);
    }
  }]);

  return CodeSplitComponent;
}(_react.Component);

CodeSplitComponent.propTypes = {
  path: _react.PropTypes.any.isRequired,
  onError: _react.PropTypes.func,
  children: _react.PropTypes.func.isRequired,
  noCodeSplitting: _react.PropTypes.bool
};

exports.default = CodeSplitComponent;